EDIT - bug #9642

hibernate.QueryException in OccurrenceDaoHibernatelmpl.countMedia()
06/01/2021 02:00 PM - Andreas Kohlbecker

Status: Closed Start date:
Target version: Release 5.24

Severity: normal Found in Version:

Description

12:55:00.629 [flora-malesiana] [gtpl511785794-17712] INFO e.e.c.r.c.DerivedUnitFacadeController -
doGetFieldObjectMediaDTO() - /flora—-malesiana/derivedUnitFacade/bf6dad4d82-ace7-4029-8182-67c823a46
274/fieldObjectMediaDTO

12:55:00.645 [flora-malesiana] [gtpl511785794-17712] WARN e.e.cdm.servlet.DateHeaderFilter - Can

not add data header.

org.springframework.web.util.NestedServletException: Request processing failed; nested exception i
s org.hibernate.QueryException: could not resolve property: media of: eu.etaxonomy.cdm.model.occur
rence.SpecimenOrObservationBase [SELECT count (media) FROM eu.etaxonomy.cdm.model.occurrence.Specim

enOrObservationBase occurence JOIN occurence.media media WHERE occurence = :occurence]

Caused by: org.hibernate.QueryException: could not resolve property: media of: eu.etaxonomy.cdm.mo
del.occurrence.SpecimenOrObservationBase [SELECT count (media) FROM eu.etaxonomy.cd
m.model.occurrence.SpecimenOrObservationBase occurence JOIN occurence.media media WHERE occurence
= :occurence]

at org.hibernate.QueryException.generateQueryException (QueryException. java:120)

at org.hibernate.QueryException.wrapWithQueryString (QueryException.java:103)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.doCompile (QueryTranslatorImpl. java:2
17)

at org.hibernate.hgl.internal.ast.QueryTranslatorImpl.compile (QueryTranslatorImpl. java:141

at org.hibernate.engine.query.spi.HQLQueryPlan.<init> (HQLQueryPlan. java:115)

at org.hibernate.engine.query.spi.HQLQueryPlan.<init> (HQLQueryPlan. java:76)

at org.hibernate.engine.query.spi.QueryPlanCache.getHQLQueryPlan (QueryPlanCache. java:150)
at org.hibernate.internal.AbstractSessionImpl.getHQLQueryPlan (AbstractSessionImpl. java:302

at org.hibernate.internal.AbstractSessionImpl.createQuery (AbstractSessionImpl. java:240)

at org.hibernate.internal.SessionImpl.createQuery (SessionImpl. java:1907)

at eu.etaxonomy.cdm.persistence.dao.hibernate.occurrence.OccurrenceDaoHibernateImpl.countM
edia (OccurrenceDaoHibernateImpl. java:136)

at eu.etaxonomy.cdm.api.service.OccurrenceServiceImpl.getMediaDTOs (OccurrenceServicelImpl. j

ava:201)
at sun.reflect.GeneratedMethodAccessor8934.invoke (Unknown Source)
at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
at java.lang.reflect.Method.invoke (Method. java:498)
at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:3
33)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (Reflective
MethodInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation. java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocat
ion(TransactionInterceptor.java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransa
ction (TransactionAspectSupport.java:283)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionIn
terceptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodIn
vocation.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213
at com.sun.proxy.S$Proxy6843.getMediaDTOs (Unknown Source)

at eu.etaxonomy.cdm.remote.controller.DerivedUnitFacadeController.lambda$doGetFieldObjectM
ediaDTO0S$0 (DerivedUnitFacadeController. java:115)

at java.util.stream.ReferencePipeline$3$1.accept (ReferencePipeline. java:193)

at java.util.ArrayList$ArraylListSpliterator.forEachRemaining (ArrayList.java:1382)

at java.util.stream.AbstractPipeline.copyInto (AbstractPipeline. java:481)

at java.util.stream.AbstractPipeline.wrapAndCopyInto (AbstractPipeline.java:471)

at java.util.stream.ReduceOps$ReduceOp.evaluateSequential (ReduceOps. java:708)

at java.util.stream.AbstractPipeline.evaluate (AbstractPipeline. java:234)

at java.util.stream.ReferencePipeline.collect (ReferencePipeline.java:499)

at eu.etaxonomy.cdm.remote.controller.DerivedUnitFacadeController.doGetFieldObjectMediaDTO
(DerivedUnitFacadeController. java:117)

at sun.reflect.GeneratedMethodAccessor8812.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke (InvocableHandler
Method. java:205)

at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest (Invocabl
eHandlerMethod. java:133)

at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.inv
okeAndHandle (ServletInvocableHandlerMethod. java:97)

at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invo
keHandlerMethod (RequestMappingHandlerAdapter. java:854)

at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.hand
leInternal (RequestMappingHandlerAdapter.java:765)

at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle (Abstract
HandlerMethodAdapter. java:85)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet. java:967

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet.java:901)
at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:9
70)

Associated revisions

Revision d6a8517c - 06/01/2021 05:01 PM - Andreas Miiller

fix #9642 fix countMedia and getMedia in OccurrenceDaoHibernatelmpl

Revision 7¢47b73f - 06/02/2021 09:15 AM - Andreas Miiller

ref #9642 remove unnecessary order by

Revision 678da343 - 06/02/2021 10:40 AM - Andreas Kohlbecker

ref #9642 adapting test method to more media appearing in the derivate path view

History

#1 - 06/01/2021 02:42 PM - Andreas Kohlbecker

- Subject changed from hibernate.QueryException in derivedUnitFacade/{uuid}/fieldObjectMediaDTO to hibernate.QueryException in
OccurrenceDaoHibernatelmpl.countMedia()

- Category changed from cdmlib-remote to cdmlib

- Assignee changed from Andreas Kohlbecker to Andreas Miller

#2 - 06/01/2021 05:01 PM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|d6a8517c4b8892a03e449dfe3c751036ee570bd6.

#3 - 06/01/2021 05:05 PM - Andreas Miiller
- Assignee changed from Andreas Miller to Andreas Kohlbecker

- Target version changed from Release 5.25 to Release 5.24
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/d6a8517c4b8892a03e449dfe3c751036ee570bd6

The method countMedia and getMedia in Occurrencelmpl was not correctly updated after media was removed from SpecimenOrObservationBase
years ago.

| updated the method to collect all media attached to a SpecimenOrObservationBase via an ImageGallery and, if the specimen is a MediaSpecimen,
the media for the media specimen.

#4 - 06/01/2021 05:05 PM - Andreas Miiller

please review

#5 - 06/02/2021 08:46 AM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Miller

In principle OK. In case of MediaSpecimens the list of Media ids collected by getMedialds() is sorted twice: fist by the mysql server, then by the
cdmlib. This can be avoided by the following change:

e remove: ORDER BY m.id
e move Collections.sort(list); out of the if statement block right above the return.

| guess there is still a test to be adapted?

The ticket can be closed, once these two points are handled

#6 - 06/02/2021 09:13 AM - Andreas Miiller

- Assignee changed from Andreas Muiller to Andreas Kohlbecker
Andreas Kohlbecker wrote:

In principle OK. In case of MediaSpecimens the list of Media ids collected by getMedialds() is sorted twice: fist by the mysql server, then by the
cdmlib. This can be avoided by the following change:

e remove: ORDER BY m.id
¢ move Collections.sort(list); out of the if statement block right above the return.

| guess there is still a test to be adapted?

The ticket can be closed, once these two points are handled

This is somehow true but there is a reasons for doing it the way it is implemented:

Ordering takes place in mysgl anyway due to "DISTINCT", therefore there is no overhead for order by in SQL.
But there is a (small) overhead by running java sort on all specimen, not only the media specimen.

Additionally the media specimen will only add max. 1 id to the list, so even if the above assumption is not true the additional sorting of a mostly
presorted list will be extremely small.

| guess there is still a test to be adapted?
whyt exactly do you mean?

#7 - 06/02/2021 09:15 AM - Andreas Miiller

But | removed the order by from the media specimen sql. As this query always returns max 1 result order by is not necessary.

#8 - 06/02/2021 10:16 AM - Andreas Kohlbecker
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

Andreas Muller wrote:

| guess there is still a test to be adapted?

whyt exactly do you mean?

Isn't this related to the "Tests fiir countMedia" currently being discussed by email?
#9 - 06/02/2021 10:20 AM - Andreas Miiller

- Assignee changed from Andreas Miiller to Andreas Kohlbecker

Andreas Kohlbecker wrote:
Andreas Muller wrote:

| guess there is still a test to be adapted?

whyt exactly do you mean?

Isn't this related to the " Tests fiir countMedia" currently being discussed by email?

Ahh, you mean the dataportal test? Yes, this is true, this needs to be adapted.

#10 - 06/02/2021 10:41 AM - Andreas Kohlbecker
- Status changed from Feedback to Closed
- Assignee changed from Andreas Kohlbecker to Andreas Miiller

- % Done changed from 50 to 100

Done
